# -*- coding: utf-8 -*-
from setuphelpers import *

bin_name_string = "spsetup-%s.exe"


def update_package():
    print("Downloading/Updating package content from upstream binary sources")

    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    bin_name_temp = "spsetup.exe"
    url_dl = bs_find(
        "https://www.ccleaner.com/speccy/download/standard",
        "a",
        "class",
        "text-semibold",
        headers={"User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101 Firefox/78.0"},
        proxies=proxies,
    )["href"]
    latest_bin = bin_name_temp
    version = "0"

    # print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Checking version from file
        download_html = wgets("https://www.ccleaner.com/speccy/version-history", proxies=proxies).splitlines()
        for line in download_html:
            if "latest-version" in line:
                version_from_file = line.split("v")[-1].split("<")[0]

        if version != version_from_file:
            os.rename(latest_bin, bin_name_string % version_from_file)
            version = version_from_file

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    remove_outdated_binaries(version)
